<?php
/**
 * wishbone back compat functionality
 *
 * Prevents wishbone from running on WordPress versions prior to 4.4,
 * since this theme is not meant to be backward compatible beyond that and
 * relies on many newer functions and markup changes introduced in 4.4.
 *
 * @package WordPress
 * @subpackage wishbone
 * @since wishbone 1.0
 */

/**
 * Prevent switching to wishbone on old versions of WordPress.
 *
 * Switches to the default theme.
 *
 * @since wishbone 1.0
 */
function wishbone_switch_theme() {
	switch_theme( WP_DEFAULT_THEME, WP_DEFAULT_THEME );

	unset( $_GET['activated'] );

	add_action( 'admin_notices', 'wishbone_upgrade_notice' );
}
add_action( 'after_switch_theme', 'wishbone_switch_theme' );

/**
 * Adds a message for unsuccessful theme switch.
 *
 * Prints an update nag after an unsuccessful attempt to switch to
 * wishbone on WordPress versions prior to 4.4.
 *
 * @since wishbone 1.0
 *
 * @global string $wp_version WordPress version.
 */
function wishbone_upgrade_notice() {
	$message = sprintf( esc_html__( 'Wishbone requires at least WordPress version 4.4. You are running version %s. Please upgrade and try again.', 'jt-wishbone' ), $GLOBALS['wp_version'] );
	printf( '<div class="error"><p>%s</p></div>', $message );
}

/**
 * Prevents the Customizer from being loaded on WordPress versions prior to 4.4.
 *
 * @since wishbone 1.0
 *
 * @global string $wp_version WordPress version.
 */
function wishbone_customize() {
	wp_die( sprintf( esc_html__( 'wishbone requires at least WordPress version 4.4. You are running version %s. Please upgrade and try again.', 'jt-wishbone' ), $GLOBALS['wp_version'] ), '', array(
		'back_link' => true,
	) );
}
add_action( 'load-customize.php', 'wishbone_customize' );

/**
 * Prevents the Theme Preview from being loaded on WordPress versions prior to 4.4.
 *
 * @since wishbone 1.0
 *
 * @global string $wp_version WordPress version.
 */
function wishbone_preview() {
	if ( isset( $_GET['preview'] ) ) {
		wp_die( sprintf( esc_html__( 'wishbone requires at least WordPress version 4.4. You are running version %s. Please upgrade and try again.', 'jt-wishbone' ), $GLOBALS['wp_version'] ) );
	}
}
add_action( 'template_redirect', 'wishbone_preview' );
